
%Get primal-dual gap for tgv-based jpeg 2000 decompression



function [tgv,gap,ID] = get_gap(x,y,r,data,w_level,filter_name,p,gamma,alph1,alph0)

if (p==inf)
    q=1;
elseif (p==1)
    q = inf;
else
    q = p/(p-1);
end

n=size(x,1); m=size(x,2);
[sn,sm] = size(data);

    %Get TGV-norm
        
        z0 =  cat(3,fgrad_1(x(:,:,1))-x(:,:,2:3),sym_bgrad_2(x(:,:,2:3)));
        tgv = alph1*sum(sum(sqrt(z0(:,:,1).^2 + z0(:,:,2).^2))) + alph0*sum(sum(sqrt(z0(:,:,3).^2 + z0(:,:,4).^2 + 2*(z0(:,:,5).^2))));
        
        
    %Get data term for duality gap
        
        %Get K*|div p -W^* w|##############################################
        
	%Set K to p norm of u
        K = gamma*p_norm(x(:,:,1),p);
        
        %Get divergence of q
        divq_storage =  fdiv_2(y(:,:,3:5));
        
        %Set beta to get norm of div q below alph1
        data_storage = sqrt( divq_storage(:,:,1).^2 + divq_storage(:,:,2).^2 );
        beta = max(max( data_storage ));
        beta = alph1/( max(alph1,beta) );
        
        data_storage = beta*bdiv_1(divq_storage) + wavetrans(r,-w_level,'orthogonal',filter_name);
                        
        %Get norm of d1
        nd1 = K* p_norm( data_storage , q);

        
        %Get I_D (Wu)######################################################
        %Set data storage to Wu
        
       	data_storage = wavetrans(x(:,:,1),w_level,'standard',filter_name);

        %Set all values outside the data intervals    
        data_storage  = abs( data_storage(1:sn,1:sm) - data );

        %Get l1 norm
        nd0 = sum(sum( gamma*abs( r(1:sn,1:sm) ).*data_storage ));
        
        ID = nd0;
        
        %Get d.*w##########################################################
        nd2 = sum(sum( data.*r(1:sn,1:sm) ));
        
        
        %Sum up############################################################
        gap = tgv + nd0 + nd1 + nd2;

       
        %Normalize gap and tgv
        gap = gap./(n*m);
        tgv = tgv./(n*m);
        ID = ID./(n*m);
end


%P-norm of scalar valued matrix
function [result] = p_norm(x,p)

    if (p~=inf)
        
        result = ( sum(sum(abs(x).^p)) ) ^(1/p);
        
    elseif (p==inf)
       
        result = max(max(abs(x)));
        
        if isempty(result)
            result = 0;
        end
    end


end

