%Function to get the normalizing matrix for the wavelet operator

function [C] = get_norm_matrix(n,m,filter_name,w_norm)

    %Get normalizing matrix for wavelet operator
    C = zeros(n,m);
    
    size_n = zeros(w_level+1);
    size_m = zeros(w_level+1);
    size_n(1) = n;
    size_m(1) = m;
    [lp,hp] = get_filters(filter_name);
    nlp = sqrt(2)*sum(abs(lp));
    nhp = sqrt(2)*sum(abs(hp));
    for it_i = 1:w_level
        size_n(it_i+1) = ceil(size_n(it_i)/2);
        size_m(it_i+1) = ceil(size_m(it_i)/2);
        %Set C to filter-norm estimation on each block of each resolution
        %level. Note that we assume uniform filters for all color
        %components
        C(size_n(it_i+1)+1:size_n(it_i),size_m(it_i+1)+1:size_m(it_i)) = 1/((nhp^2)*(nlp^(2*(it_i-1))));
        C(1:size_n(it_i+1),size_m(it_i+1)+1:size_m(it_i)) = 1/(nhp*nlp*(nlp^(2*(it_i-1))));
        C(size_n(it_i+1)+1:size_n(it_i),1:size_m(it_i+1)) = 1/(nhp*nlp*(nlp^(2*(it_i-1))));
    end
    %Set C such that ||CW|| = 1
    C(1:size_n(w_level+1),1:size_m(w_level+1)) = 1/(nlp^(2*w_level));
    
    %Multiply such that ||CW|| = w_norm
    C = C.*w_norm;

end