

function [u] = wavetrans(u,level,mode,filter_name)

if strcmp(filter_name,'LeGall') || strcmp(filter_name,'CDF')
	
	%Get wavelet filters
	[lp,hp,lpr,hpr] = get_filters(filter_name);

    
    if (strcmp(mode,'standard'))
        
        u = wavelet(u,level,lp,hp,lpr,hpr);
        
    elseif (strcmp(mode,'orthogonal'))
                
        u = wavelet_orth(u,level,lp,hp,lpr,hpr);
        
    else
        
        error('Wrong DWT-mode');
        
    end

else
	if (strcmp(mode,'standard')) && level > 0
		
		level = abs(level);
		[n,m] = size(u);
		
		for i=1:level
			n=n/2; m = m/2;
			[u(1:n,1:m),u(1:n,m+1:2*m),u(n+1:2*n,1:m),u(n+1:2*n,m+1:2*m)] = dwt2(u(1:2*n,1:2*m),filter_name);
		end
		
		
	elseif (strcmp(mode,'orthogonal')) || level < 0

		level = abs(level);
		[n,m] = size(u);
		n=n/(2^level); m = m/(2^level);

		for i=1:level
			u(1:2*n,1:2*m) = idwt2(u(1:n,1:m),u(1:n,m+1:2*m),u(n+1:2*n,1:m),u(n+1:2*n,m+1:2*m),filter_name);
			n=2*n; m=2*m;
		end
	end

end
